.nolist
include \masm32\include\masm32rt.inc

ShowWinErr	PROTO:DWORD

COMMENT @ ticks & mem usage
		Ticks	Mem	Handles GDI
Heap		12000		87		12		4
SysAll	10000		87		14		4
@


MemCop	EQU	0	; change to 1 for using MemCopy


Loops	EQU	80	; add 00 for a longer session ;-)
Strings	EQU	5000	; 8000*5000*66000=2.64E+012


; OPT_Out	omsH.exe
; OPT_DelTmp	0
; OPT_DelObj	1	; keep object files?

.data?
UseHeap	dd ?	; 1000*2000*66k: 79.97/163 secs Heap, 49 SysAlloc
Ticks	dd ?
ProcHeap	dd ?
ShowErrBuf	dd 100 dup(?)	; 200 chars for Windows errors
StringTable	dd Strings dup (?)	; pointers to string variables

s64k	db 64000 dup (?)
s2k	db 2000 dup (?)

.data
ShowErr	db "Windows error:", 13, 10, 0

s10	db "1234567890", 0		; ten bytes
s2k_tocopy	db "x234567890", 0		; 2000
s64k_tocopy	db "A234567890", 0		; 64000

.code

start:	pushad

	xor ebx, ebx
	.While ebx<200
		invoke lstrcat, addr s2k, addr s2k_tocopy
		inc ebx
	.Endw
	xor ebx, ebx
	.While ebx<6400
		invoke lstrcat, addr s64k, addr s64k_tocopy
		inc ebx
	.Endw

	invoke GetProcessHeap		; needed for HeapAlloc
	mov ProcHeap, eax
	inc UseHeap		; skip SysAlloc
	.REPEAT
	print chr$(13, 10, "Loop ")
	invoke GetTickCount
	mov Ticks, eax
	xor esi, esi			; outer loop counter
	.While esi<Loops
		xor ebx, ebx	; inner loop counter
		.While ebx<Strings
			lea edi, [StringTable+4*ebx]
			mov eax, [edi]
			.if eax
				.if UseHeap
					invoke HeapFree, ProcHeap, 0, eax
				.else
					invoke SysFreeString, eax
				.endif
			.endif
			mov edx, offset s10	; default: a short string
			mov eax, ebx
			add eax, esi	; pseudo-random generator
			bt eax, 0
			.if CARRY?		; odd
				mov edx, offset s2k
			.else
				bt eax, 1
				.if CARRY?
					mov edx, offset s64k
				.endif
			.endif
			.if UseHeap
				push edx
				mov ecx, len(edx)
				inc ecx
				push ecx
				invoke HeapAlloc, ProcHeap,
				HEAP_GENERATE_EXCEPTIONS or HEAP_ZERO_MEMORY, ecx
				pop ecx
				pop edx
				.if eax
					mov [edi], eax		; pointer into stringtable
					if MemCop
						invoke MemCopy, edx, [edi], ecx
					else
						.if ecx > 1024
							push esi
							push edi
							push ecx
							mov esi, edx
							mov edi, [edi]
							shr ecx, 2
							rep movsd
							pop ecx
							and ecx, 3
							rep movsb
							pop edi
							pop esi
						.else
							push ebx
							push esi
							push edi
							mov esi, edx
							mov edi, [edi]
							mov ebx, -1
						@@:
							add ebx, 1
							; movzx eax, BYTE PTR [esi+ebx]
							mov al, [esi+ebx]
							mov [edi+ebx], al
							cmp ebx, ecx
							jle @B
							pop edi
							pop esi
							pop ebx
						.endif
					endif
				.else
					invoke ShowWinErr, 1	; show formatted error
					mov esi, 999999		; get out of the outer loop, too
					.break
				.endif
			.else
				invoke SysAllocStringByteLen, edx, len(edx)
				.if eax
					mov [edi], eax
				.else
					invoke ShowWinErr, 1	; show formatted error
					mov esi, 999999		; get out of the outer loop, too
					.break
				.endif
			.endif
			inc ebx		; inner loop counter
		.Endw
		inc esi			; outer loop counter
		; give us some feedback on where you are...
		print chr$(13, "Loop ")
		print str$(esi)
		print chr$(" - len of first string is ")
		lea edi, [StringTable]
		.if UseHeap
			mov eax, len([edi])
			; inc eax
			; invoke StdOut, [edi]	; the string itself
		.else
			invoke SysStringByteLen, [edi]
		.endif
		print str$(eax)
		; invoke StdOut, [edi]	; the string itself
	.Endw
	.While ebx			; free the strings allocated in the last inner loop
		dec ebx
		lea edi, [StringTable+4*ebx]
		mov eax, [edi]
		.if eax
			.if UseHeap
				invoke HeapFree, ProcHeap, 0, eax
			.else
				invoke SysFreeString, eax
			.endif
		.endif
	.Endw
	print chr$(13, 10, "Ticks, UseHeap=")
	print str$(UseHeap)
	print chr$(" : ")
	invoke GetTickCount		; get the timing
	sub eax, Ticks
	push eax
	print str$(eax)
	pop eax
;	invoke MessageBox, 0, str$(eax), chr$("Ticks:"), MB_OKCANCEL
	inc UseHeap
	.UNTIL UseHeap==2 || eax==IDCANCEL
	popad
	invoke ExitProcess, 0

ShowWinErr proc ShowFormatted:DWORD
 pushad
 invoke GetLastError
 .if ShowFormatted
	invoke FormatMessage,FORMAT_MESSAGE_FROM_SYSTEM,
	0,	; GetItFromSystem
	eax,	; ErrNum
	0,	; Default language
	addr ShowErrBuf,			; where to send the string from system
	400, 0          				; size 400, no arguments
	.if ShowFormatted!=1
		invoke lstrcat, addr ShowErrBuf, ShowFormatted
	.endif
	invoke MessageBox, 0, addr ShowErrBuf, addr ShowErr, MB_OK
 .else
	invoke MessageBox, 0, str$(eax), addr ShowErr, MB_OK
 .endif
 popad
ret
ShowWinErr endp

end start

Gfa: 93000 for 50*900
; OPT_Icon	Eye
; OPT_SUSY	CONSOLE
; OPT_WAIT	1
; OPT_RUN	omsH.exe

http://www.masm32.com/board/index.php?topic=1915.0

These are the two macros in MASM32 but it has the correct API calls.

Code:
      alloc$ MACRO ln
        invoke SysAllocStringByteLen,0,ln
        mov BYTE PTR [eax], 0
        EXITM <eax>
      ENDM

      free$ MACRO strhandle
        invoke SysFreeString,strhandle
      ENDM
